<template>
  <el-breadcrumb class="app-breadcrumb" separator="/">
    <transition-group name="breadcrumb">
      <el-breadcrumb-item v-for="(item,index) in comLevelList" :key="item.path">
        <el-dropdown v-if="index==1">
          <span class="el-dropdown-link" @mouseenter="getRouterDropboxList(index)">
            {{ item.meta.title }}<i class="el-icon-arrow-down el-icon--right" />
          </span>
          <el-dropdown-menu slot="dropdown">
            <el-dropdown-item v-for="(i,indexx) in routesDropboxlist" :key="indexx" :label="i.path" @click.native="dropboxGoToPath(i.path)">{{ i.title }}</el-dropdown-item>
          </el-dropdown-menu>
        </el-dropdown>
        <span
          v-else-if="item.redirect==='noRedirect'||index==comLevelList.length-1"
          class="no-redirect"
        >{{ item.meta.title }}</span>
        <a v-else @click.prevent="handleLink(item)">{{ item.meta.title }}</a>
      </el-breadcrumb-item></transition-group>
  </el-breadcrumb>
</template>

<script>
import pathToRegexp from 'path-to-regexp'
import constantRoutes from '@/router'
export default {
  data() {
    return {
      levelList: null,
      routesDropboxlist: []
    }
  },
  computed: {
    // 修改麵包屑的長度
    comLevelList: function() {
      const arr = []
      for (var i = 0; i < this.levelList.length; i++) {
        if (i === 3) {
          break
        }
        arr.push(this.levelList[i])
      }
      return arr
    }
  },
  watch: {
    $route() {
      this.getBreadcrumb()
    }
  },
  created() {
    this.getBreadcrumb()
  },
  methods: {
    dropboxGoToPath(path) {
      this.$router.push(path)
    },
    getRouterDropboxList(index) {
      if (index === 1) {
        this.routesDropboxlist = []
        for (var i = 0; i < constantRoutes.options.routes.length; i++) {
          if (constantRoutes.options.routes[i].path === this.levelList[index].path) {
            for (var j = 0; j < constantRoutes.options.routes[i].children.length; j++) {
              var title = constantRoutes.options.routes[i].children[j].meta.title
              var path = constantRoutes.options.routes[i].children[j].redirect
              this.routesDropboxlist.push({ title: title, path: path })
            }
          }
        }
      }
    },
    getBreadcrumb() {
      // only show routes with meta.title
      let matched = this.$route.matched.filter(
        item => item.meta && item.meta.title
      )
      const first = matched[0]

      if (!this.isDashboard(first)) {
        matched = [{ path: '/dashboard', meta: { title: '首頁' }}].concat(
          matched
        )
      }

      this.levelList = matched.filter(
        item => item.meta && item.meta.title && item.meta.breadcrumb !== false
      )
    },
    isDashboard(route) {
      const name = route && route.name
      if (!name) {
        return false
      }
      return name.trim().toLocaleLowerCase() === 'Dashboard'.toLocaleLowerCase()
    },
    pathCompile(path) {
      // To solve this problem https://github.com/PanJiaChen/vue-element-admin/issues/561
      const { params } = this.$route
      var toPath = pathToRegexp.compile(path)
      return toPath(params)
    },
    handleLink(item) {
      const { redirect, path } = item
      if (redirect) {
        this.$router.push(redirect)
        return
      }
      this.$router.push(this.pathCompile(path))
    }
  }
}
</script>

<style lang="scss" scoped>
.app-breadcrumb.el-breadcrumb {
  display: inline-block;
  font-size: 14px;
  line-height: 50px;
  margin-left: 8px;
  color: black;
  .no-redirect {
    color: #a36a00;
    cursor: text;
  }
}
</style>
